local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_TARGET_CHANGED")
DEFAULT_CHAT_FRAME:AddMessage("Class Announcer v1.1.0 Loaded.", 0.0, 1.0, 0.0)
DEFAULT_CHAT_FRAME:AddMessage("Type /clann to view status.", 0.0, 1.0, 0.0)
 
if (CLASSANNOUNCER_ENABLED ~= "1") and (CLASSANNOUNCER_ENABLED ~= "0") then
   		CLASSANNOUNCER_ENABLED = "1";
end

 function Classannouncer_OnLoad(self)
  
end

f:SetScript("OnEvent", function(self, event, unit)

	if event == "PLAYER_TARGET_CHANGED" then
		
	local targetClass = UnitClass("target");
		
		 if not (UnitIsFriend("player","target")) and (CLASSANNOUNCER_ENABLED == "1") then
	--				if  (CLASSANNOUNCER_ENABLED == "1") then -- for testing vs friendlies
		


	-- Check for classes...	
				if (targetClass == "Warrior") then
									PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\Warrior.mp3");
				end
				
				if (targetClass == "Mage") then
									PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\mage.mp3");
				end
			
				if (targetClass == "Shaman") then
									PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\Shaman.mp3");
				end

				if (targetClass == "Priest") then
									PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\Priest.mp3");
				end				
			
				if (targetClass == "Rogue") then
									PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\Rogue.mp3");
				end				
				
				if (targetClass == "Paladin") then
									PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\Paladin.mp3");
				end				
				
				if (targetClass == "Hunter") then
									PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\hunter.mp3");
				end				
				
				if (targetClass == "Druid") then
									PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\Druid.mp3");
				end				
				
				if (targetClass == "Warlock") then
									PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\Warlock.mp3");
				end					

				if (targetClass == "Death Knight") then
									PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\DeathKnight.mp3");
				end					
				
				if (targetClass == "Monk") then
									PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\Monk.mp3");
				end		
	
--Get unit GUID, to determine if it's a pet....
				local guid = UnitGUID("target");
-- trap a null GUID, ignore if it is null
				if not (guid == "") then 
					local B = tonumber(guid:sub(5,5), 16);
					local maskedB = B % 8; -- x % 8 has the same effect as x & 0x7 on numbers <= 0xf
					local knownTypes = {[0]="player", [3]="NPC", [4]="pet", [5]="vehicle"};
				
					if (knownTypes[maskedB] == "pet") then
						PlaySoundFile("Interface\\Addons\\Classannouncer\\Sounds\\Pet.mp3");
					end
				end
	
	
		-- Check for Smoke Bomb		
--								for i = 1, 40 do
--				 				spellname, _, icon, _, _, duration, expirationTime, _, _, _, spellId = UnitAura("target", i)
--									if spellname == "Smoke Bomb" then
--									DEFAULT_CHAT_FRAME:AddMessage("SMOKE BOMB", 255, 0, 0);
--									end
--								end				
			end
	end
end)

-- Handle slash commands
function CLASSANNOUNCER_Command(cmd)
if (strlower(cmd) == "on") then
	CLASSANNOUNCER_ENABLED = "1";
    DEFAULT_CHAT_FRAME:AddMessage("Class Announcer Enabled.", 0.0, 1.0, 0.0);
end

if (strlower(cmd) == "off") then
	CLASSANNOUNCER_ENABLED = "0";
    DEFAULT_CHAT_FRAME:AddMessage("Class Announcer Disabled.", 0.0, 1.0, 0.0);
end

if (strlower(cmd) == "") then
	if CLASSANNOUNCER_ENABLED == "1" then
    	DEFAULT_CHAT_FRAME:AddMessage("Class Announcer is currently Enabled.", 0.0, 1.0, 0.0);
    	    	DEFAULT_CHAT_FRAME:AddMessage("Type '/clann off' to disable.", 0.0, 1.0, 0.0);
    end
    if CLASSANNOUNCER_ENABLED == "0" then
    	DEFAULT_CHAT_FRAME:AddMessage("Class Announcer is currently Disabled.", 0.0, 1.0, 0.0);
    	    	DEFAULT_CHAT_FRAME:AddMessage("Type '/clann on' to enable.", 0.0, 1.0, 0.0);
    end
end
end


-- Listener for slash command
SLASH_CLASSANNOUNCER1 = "/clann";
SlashCmdList["CLASSANNOUNCER"] = CLASSANNOUNCER_Command;